#ifndef __FONT__
#define __FONT__

#include <stdint.h>
#include <stdlib.h>
#include <avr/pgmspace.h>
#include "include/t6963c.h"

#define TRANS			0
#define SOLID			1
#define INVERSE			2


struct FONT_DEF {
   const uint8_t glyph_width;		/* glyph width in pixels              	*/
						/*     0 for variable width fonts     	*/
   const uint8_t glyph_height;             /* glyph height for storage           	*/
   const uint8_t *glyph_table;         	/* font table start address in memory 	*/
   const uint8_t *mapping_table;       	/* used to find the index of a glyph  	*/
   const uint8_t *width_table;         	/* width table start adress           	*/
						/*        NULL for fixed width fonts  	*/
   const unsigned int *offset_table;         	/* ks the offsets of the first byte	*/
};

extern void GLCD_PRINT_P(glcd_x_t x, glcd_y_t y, const char *in, const struct FONT_DEF * const fnt, uint8_t invers);
extern void GLCD_PRINT(glcd_x_t x, glcd_y_t y, const char *in, const struct FONT_DEF * const fnt, uint8_t invers);
extern int GLCD_STRLEN(const char *in, const struct FONT_DEF * const fnt);
int GLCD_STRLEN_P(const char *in, const struct FONT_DEF * const fnt);
#define GLCD_STRWIDTH(in,fnt) GLCD_STRLEN(in,fnt)
#define GLCD_STRWIDTH_P(in,fnt) GLCD_STRLEN_P(in,fnt)
extern uint8_t GLCD_CHAR(glcd_x_t x, glcd_y_t y, char in, const struct FONT_DEF * const fnt);
#define GLCD_PRINT_p(__x, __y, __in, __s1, __i)       GLCD_PRINT_P(__x,__y,PSTR(__in),__s1,__i)
int GLCD_GET_FONT_HEIGHT( const struct FONT_DEF * const fnt );
void GLCD_plot_bitmap(glcd_x_t x_off, glcd_y_t y_off, const uint8_t *bitmap, glcd_x_t w, glcd_y_t h, uint8_t rev);
#endif


