#include <avr/pgmspace.h>

#include "include/config.h"
#include "include/general.h"
#include "include/t6963c.h"
#include "include/graphics.h"
#include "include/inputs.h"
#include "include/font.h"

static const unsigned char x_table[] PROGMEM = {
88, // 45 = -
77, // 46 = .
0, // 47 = /
111, // 48 = 0
3, // 49 = 1
15, // 50 = 2
27, // 51 = 3
39, // 52 = 4
51, // 53 = 5
64, // 54 = 6
76, // 55 = 7
87, // 56 = 8
99, // 57 = 9
0, // 58 = :
0, // 59 = ;
0, // 60 = <
0, // 61 = =
0, // 62 = >
0, // 63 = ?
0, // 64 = @
2, // 65 = A
15, // 66 = B
27, // 67 = C
39, // 68 = D
51, // 69 = E
63, // 70 = F
74, // 71 = G
86, // 72 = H
101, // 73 = I
110, // 74 = J
2, // 75 = K
15, // 76 = L
26, // 77 = M
39, // 78 = N
50, // 79 = O
63, // 80 = P
74, // 81 = Q
86, // 82 = R
99, // 83 = S
110, // 84 = T
2, // 85 = U
15, // 86 = V
24, // 87 = W
39, // 88 = X
50, // 89 = Y
63, // 90 = Z
0, // 91 = [
0, // 92 =  
0, // 93 = ]
0, // 94 = ^
98, // 95 = _
0, // 96 = `
3, // 97 = a
15, // 98 = b
27, // 99 = c
39, // 100 = d
51, // 101 = e
63, // 102 = f
75, // 103 = g
87, // 104 = h
102, // 105 = i
111, // 106 = j
3, // 107 = k
17, // 108 = l
26, // 109 = m
39, // 110 = n
51, // 111 = o
63, // 112 = p
75, // 113 = q
88, // 114 = r
99, // 115 = s
112, // 116 = t
3, // 117 = u
15, // 118 = v
25, // 119 = w
39, // 120 = x
51, // 121 = y
63 // 122 = z
};


void GUI_KEYBOARD_SHOW(char *label, char *text, int type )
{
  uint16_t xo = 4;
  uint16_t yo = 50;
  uint16_t x, y;
  uint16_t xpos;
  uint16_t ypos;
  int px = 0;
  ypos = yo;
  
  GLCD_CLEAR();
  
  px = GLCD_STRLEN(label,GUI_STANDARD_FONT);
  px = 64-(px/2);

  GLCD_BOX_FILLED(0, 0, 127, 12,FALSE);
  GLCD_PRINT(px, 0, label, GUI_STANDARD_FONT ,FALSE);

  GLCD_BOX_FILLED(xo, yo-20, xo+119, yo-32,FALSE);
  GLCD_PRINT(xo, yo-32, text, GUI_STANDARD_FONT ,FALSE);
  GLCD_BOX(xo, yo-20, xo+119, yo-32,TRUE);

  
  GLCD_PRINT(xo+8,yo+47,"caps",GUI_STANDARD_FONT,FALSE);
  GLCD_PRINT(xo+48,yo+47,"del",GUI_STANDARD_FONT,FALSE);
  GLCD_PRINT(xo+80,yo+47,"enter",GUI_STANDARD_FONT,FALSE);
  
  for(x = 0; x <= 120; x += 12)
  {
    GLCD_LINE(xo+x, yo, xo+x, yo+48, TRUE);
  }
  for(y = 0; y <= 48; y += 12)
  {
      GLCD_LINE(xo,yo+y,xo+120,yo+y,TRUE);
  }
  GLCD_LINE(xo,yo+60,xo+120,yo+60,TRUE);
  GLCD_LINE(xo,yo+48,xo,yo+60,TRUE);
  GLCD_LINE(xo+40,yo+48,xo+40,yo+60,TRUE);
  GLCD_LINE(xo+72,yo+48,xo+72,yo+60,TRUE);
  GLCD_LINE(xo+120,yo+48,xo+120,yo+60,TRUE);

  for(x = 0; x <= 77; x++)
  {
    xpos = pgm_read_byte(&x_table[x]);
    if( (x > 2) && (x < 14) )
    {
      GLCD_CHAR(xo+xpos,ypos,x+'-',GUI_STANDARD_FONT);
    }
    if( (x == 0) || (x == 1) || (x == 50) )
    {
      GLCD_CHAR(xo+xpos,ypos+35,x+'-',GUI_STANDARD_FONT);
    }
  }
  for(x = 0; x <= 77; x++)
  {
    xpos = pgm_read_byte(&x_table[x]);
    if(type == 0)
    {
      if((x > 19)
	  {
	    if (x < 30))
        {
		  GLCD_CHAR(xo+xpos,ypos+11,x+'-',GUI_STANDARD_FONT);
        }
        else if (x < 40)
        {
		  GLCD_CHAR(xo+xpos,ypos+23,x+'-',GUI_STANDARD_FONT);
        }
        else if (x < 50)
        {
		  GLCD_CHAR(xo+xpos,ypos+35,x+'-',GUI_STANDARD_FONT);
        }
	  }
    }
    else if (type == 1)
    {
      if((x > 51)
	    if (x < 62)
        {
		  GLCD_CHAR(xo+xpos,ypos+11,x+'-',GUI_STANDARD_FONT);
        }
        else if (x < 72)
        {
		  GLCD_CHAR(xo+xpos,ypos+23,x+'-',GUI_STANDARD_FONT);
        }
        else if (x < 86)
        {
		  GLCD_CHAR(xo+xpos,ypos+35,x+'-',GUI_STANDARD_FONT);
        }
	  }
    }
  }
}

void GUI_KEYBOARD_RUN(char *label, char *text, int type )
{
}

